<?

/*
 * $Date: 2009/10/23 11:20:56 $
 * $Revision: 1.59 $
 */

define('ZMG_PB_VERSION', '0.1');

require_once (ABSPATH . '/wp-admin/includes/post.php');

if (!defined('WP_CONTENT_URL'))
    define('WP_CONTENT_URL', get_option('siteurl') . '/wp-content');

if (!defined('WP_PLUGIN_URL'))
    define('WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins');

if (!defined('WP_CONTENT_DIR'))
    define('WP_CONTENT_DIR', ABSPATH . 'wp-content');

if (!defined('WP_PLUGIN_DIR'))
    define('WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins');

define('ZMG_PB_DIR_NAME', basename(dirname(__FILE__)));
define('ZMG_PB_URL', WP_PLUGIN_URL . '/' . ZMG_PB_DIR_NAME);
define('ZMG_PB_DIR', WP_PLUGIN_DIR . '/' . ZMG_PB_DIR_NAME);

class zmg_pagebar
{
    var $zmg_page_title   = 'Zamango Page Navigation';
    var $zmg_menu_title   = 'Page Navigation';
    var $zmg_access_level = 5;
    var $zmg_options_name = 'zmg_pagebar';
    var $zmg_options      = array();
    var $zmg_defaults_options = array (
                "left"              => 1,
                "center"            => 11,
                "right"             => 1,
                "clear_options"     => 0,
                "before_loop"       => 1,
                "after_loop"        => 1,
                "before_loop_s"     => 1,
                "after_loop_s"      => 1,
                "separator"         => "...",
                "prev_link"         => "auto",
                "next_link"         => "auto",
                "prev_tag"          => "&laquo;",
                "next_tag"          => "&raquo;",
                "prev_tag_s"        => "&laquo; [zmg_pb:prev_post]",
                "next_tag_s"        => "[zmg_pb:next_post] &raquo;",
                "first_tag"         => "[zmg_pb:page]",
                "last_tag"          => "[zmg_pb:page]",
                "curr_tag"          => "[zmg_pb:page]",
                "stnd_tag"          => "[zmg_pb:page]",
                "tooltips"          => 1,
                "ttip_tag"          => "Page [zmg_pb:page] of [zmg_pb:total]",
                "is_zmg_css"        => 1,
                "css"               => "
/************************************************/
/*           CSS for whole navigation bar       */

/* Parent DIV containing whole page navigation bar */
.zmg_pagebar {
    font-family: Verdana, Arial, Sans-Serif;
    text-align: center;
    margin: 10px;
    font-size: 90%;
    color: #121212;
    font-weight: bold;
}

/*  All links inside the navigation bar */
.zmg_pagebar a {
    margin: 0;
    padding: 5px;
    color: #121212;
    text-decoration: none;
}

.zmg_pagebar a:hover{
    background-color: #cdcdcd ;
    margin: 0;
    padding: 5px;
    text-decoration: none;
    color: #121212;
}

/*  Following declaration hides standard navigation of Classic theme  */
.navigation {
    display:none;
}


/************************************************/
/*           CSS for blogroll navigation        */

/* Current page sign */
.zmg_pb_current {
    padding: 10px;
    background-color: #dcdcdc ;
    font-weight: bold;
    font-size: 120%;
}

/* Link to next page */
.zmg_pb_next {
    background-color: #fafafa ;
}
.zmg_pb_next a:hover , .zmg_pb_next:hover {
    background-color: #cdcdcd ;
}

/* Link to previous page */
.zmg_pb_prev {
    background-color: #fafafa ;
}
.zmg_pb_prev a:hover , .zmg_pb_prev:hover {
    background-color: #cdcdcd ;
}

/* Common link */
.zmg_pb_standar, .zmg_pb_standar a {
    background-color: #fafafa ;
}
.zmg_pb_standar a:hover , .zmg_pb_standar:hover {
    background-color: #cdcdcd ;
}

/* Inactive page sign (i.e. without link) */
.zmg_pb_inactive {
    background-color: #e3e3e3 ;
}

/* Separator */
.zmg_pb_separator {
    padding: 2px;
}


/************************************************/
/*      CSS for quick links on single post      */

/* Link to previous post */
.zmg_pb_prev_post {
    float: left;
    MAX-WIDTH: 48%;
    min-height: 30px;
    text-align: left;
    margin: 5px;
    padding: 2px;
    background-color: #fafafa ;
}
.zmg_pb_prev_post a:hover , .zmg_pb_prev_post:hover {
    background-color: #cdcdcd ;
}

/* Link to next post */
.zmg_pb_next_post {
    float: right;
    MAX-WIDTH: 48%;
    min-height: 30px;
    text-align: right;
    margin: 5px;
    padding: 2px;
    background-color: #fafafa ;
}
.zmg_pb_next_post:hover  a , .zmg_pb_next_post:hover {
    background-color: #cdcdcd ;
}


/************************************************/
/*     Please don't modify following style      */
.zmg_pb_clear {
    clear: both;
}
                ",
                "in_category"       => 1,
                "fl_linking"        => 1,
                "ZMG_PB_G_OPTIONS"  => 0,
                "ZMG_PB_MP_OPTIONS" => 1,
                "ZMG_PB_SP_OPTIONS" => 0,
                "ZMG_PB_STYLE"      => 0
    );

    /*
     * 1 = main menu
     * 2 = options
     * 3 = manage
     * 4 = templates
    */

    var $zmg_add_page_to = 1;

    /*************************************************************************/
    function zmg_pagebar()
    {
        $this->zmg_fetch_options();
    }

    /*************************************************************************/
    function zmg_fetch_options()
    {
        $options = get_option($this->zmg_options_name);

        $this->zmg_options = wp_parse_args($options,
                                           $this->zmg_defaults_options);
    }

    /**************************************************************************/
    function zmg_save_options()
    {
        update_option($this->zmg_options_name, $this->zmg_options);
    }

    /*************************************************************************/
    function zmg_activate()
    {
    }

    /**************************************************************************/
    function zmg_deactivate()
    {
        if ($this->zmg_options['clear_options'])
            delete_option($this->zmg_options_name);
    }

    /**************************************************************************/
    function zmg_init()
    {
        global $wp_rewrite;

        $wp_rewrite->add_endpoint("all", EP_ALL);
        $wp_rewrite->flush_rules();

        if ($this->zmg_options["before_loop"] ||
            $this->zmg_options["before_loop_s"])
        {

            $zmg_pb_before_loop =
                new zmg_pagebar_parser ("zmg_pb_before_loop",
                                        $this->zmg_options);

            add_action ('loop_start', array($zmg_pb_before_loop, 'parse'));
        }

        if ($this->zmg_options["after_loop"] ||
            $this->zmg_options["after_loop_s"])
        {

            $zmg_pb_after_loop =
                new zmg_pagebar_parser ("zmg_pb_after_loop",
                                        $this->zmg_options);

            add_action ('loop_end', array($zmg_pb_after_loop, 'parse'));
        }
    }

    /**************************************************************************/
    function zmg_add_admin_menu()
    {
        switch ($this->zmg_add_page_to)
        {
        case 1:
            add_menu_page($this->zmg_page_title,
                          $this->zmg_menu_title,
                          $this->zmg_access_level,
                          __FILE__, array($this, 'zmg_admin_page'),
                          ZMG_PB_URL . '/img/zamango_icon.png');
            break;

        case 2:
            add_options_page($this->zmg_page_title,
                             $this->zmg_menu_title,
                             $this->zmg_access_level,
                             __FILE__, array($this, 'zmg_admin_page'));
            break;

        case 3:
            add_management_page($this->zmg_page_title,
                                $this->zmg_menu_title,
                                $this->zmg_access_level,
                                __FILE__, array($this, 'zmg_admin_page'));
            break;

        case 4:
            add_theme_page($this->zmg_page_title,
                           $this->zmg_menu_title,
                           $this->zmg_access_level,
                           __FILE__, array($this, 'zmg_admin_page'));
            break;
        }
    }

    /**************************************************************************/
    function zmg_admin_page()
    {
        load_plugin_textdomain('zmg_pagebar', ZMG_PB_URL, ZMG_PB_DIR_NAME);

        ?>
            <div class="wrap">
                <div id="zmg_logo">
                    <a target="_blank" href="http://www.zamango.com/">
                        <img src="<?= ZMG_PB_URL ?>/img/zamango_logo.png"
                             alt="Zamango" />
                    </a>
                </div>
                <h1 class="zmg_title">
                    <? _e('Page Navigation', 'zmg_pagebar'); ?>
                </h1>
                <div class="zmg_clear"></div>
                <div id="zmg_pb_top_baner">
                    <a href="http://wordpress.org/extend/plugins/zamango-money-extractor/"
                       target=_blank title="<?
                       _e('Sell software from choosen vendors by only one plugin',
                          'zmg_pagebar');
                    /*?>*/ ?>">
                    <?
                        _e('Wanna monetize your blog? It\'s easy! Just install
                            Zamango Money Extractor plugin and get easy money!',
                           'zmg_pagebar');
                    ?>
                    </a>
                </div>
                <div class="zmg_pb_clear"></div>
        <?
        if (isset($_POST['ZMG_PB_MP_OPTIONS']))
        {
            $this->zmg_options['ZMG_PB_G_OPTIONS']  = 0;
            $this->zmg_options['ZMG_PB_MP_OPTIONS'] = 1;
            $this->zmg_options['ZMG_PB_SP_OPTIONS'] = 0;
            $this->zmg_options['ZMG_PB_STYLE']      = 0;

            if (isset($_POST['left']))
                $this->zmg_options['left']   = (int) ($_POST['left']);

            if (isset($_POST['right']))
                $this->zmg_options['right']  = (int) ($_POST['right']);

            if (isset($_POST['center']))
            {
                $this->zmg_options['center'] = (int) ($_POST['center']);

                if (! $this->zmg_options['center'] % 2)
                    $this->zmg_options['center']++;
            }

            $this->zmg_options['separator'] = empty($_POST['separator'])
                ? "..." : $_POST['separator'];

            $this->zmg_options['after_loop']  = isset($_POST['after_loop']);
            $this->zmg_options['before_loop'] = isset($_POST['before_loop']);

            if (isset($_POST['prev_link']))
            {
                $this->zmg_options['prev_link'] = $_POST['prev_link'];

                if ($this->zmg_options['prev_link'] <> "never" &&
                    $this->zmg_options['prev_link'] <> "always")
                    $this->zmg_options['prev_link'] =  "auto";
            }

            if (isset($_POST['next_link']))
            {
                $this->zmg_options['next_link'] = $_POST['next_link'];

                if ($this->zmg_options['next_link'] <> "never" &&
                    $this->zmg_options['next_link'] <> "always")
                    $this->zmg_options['next_link'] =  "auto";
            }

            if (isset($_POST['prev_tag']))
                $this->zmg_options['prev_tag'] =
                    stripslashes($_POST['prev_tag']);

            if (isset($_POST['next_tag']))
                $this->zmg_options['next_tag'] =
                    stripslashes($_POST['next_tag']);

            if (isset($_POST['first_tag']))
                $this->zmg_options['first_tag'] =
                    stripslashes($_POST['first_tag']);

            if (isset($_POST['last_tag']))
                $this->zmg_options['last_tag'] =
                    stripslashes($_POST['last_tag']);

            if (isset($_POST['curr_tag']))
                $this->zmg_options['curr_tag'] =
                    stripslashes($_POST['curr_tag']);

            if (isset($_POST['stnd_tag']))
                $this->zmg_options['stnd_tag'] =
                    stripslashes($_POST['stnd_tag']);

            if (isset($_POST['tooltips']))
            {
                $this->zmg_options['tooltips'] = isset($_POST['tooltips']);

                if (isset($_POST['ttip_tag']))
                    $this->zmg_options['ttip_tag'] =
                        stripslashes($_POST['ttip_tag']);
            }

            $this->zmg_save_options();

            ?>
                <div class="updated fade">
                    <p>
            <?
                _e('Options have been successfully saved', 'zmg_pagebar');
            ?>
                    </p>
                </div>
            <?
        }
        else if (isset($_POST['ZMG_PB_G_OPTIONS']))
        {
            $this->zmg_options['ZMG_PB_G_OPTIONS']  = 1;
            $this->zmg_options['ZMG_PB_MP_OPTIONS'] = 0;
            $this->zmg_options['ZMG_PB_SP_OPTIONS'] = 0;
            $this->zmg_options['ZMG_PB_STYLE']      = 0;
        }
        else if (isset($_POST['ZMG_PB_SP_OPTIONS']))
        {
            $this->zmg_options['ZMG_PB_G_OPTIONS']  = 0;
            $this->zmg_options['ZMG_PB_MP_OPTIONS'] = 0;
            $this->zmg_options['ZMG_PB_SP_OPTIONS'] = 1;
            $this->zmg_options['ZMG_PB_STYLE']      = 0;

            $this->zmg_options['fl_linking']    = isset($_POST['fl_linking']);
            $this->zmg_options['in_category']   = isset($_POST['in_category']);
            $this->zmg_options['after_loop_s']  = isset($_POST['after_loop_s']);
            $this->zmg_options['before_loop_s'] =
                isset($_POST['before_loop_s']);

            if (isset($_POST['prev_tag_s']))
                $this->zmg_options['prev_tag_s'] =
                    stripslashes($_POST['prev_tag_s']);

            if (isset($_POST['next_tag_s']))
                $this->zmg_options['next_tag_s'] =
                    stripslashes($_POST['next_tag_s']);

            $this->zmg_save_options();

            ?>
                <div class="updated fade">
                    <p>
            <?
                _e('Options have been successfully saved', 'zmg_pagebar');
            ?>
                    </p>
                </div>
            <?
        }
        else if (isset($_POST['ZMG_PB_STYLE']))
        {
            $this->zmg_options['ZMG_PB_G_OPTIONS']  = 0;
            $this->zmg_options['ZMG_PB_MP_OPTIONS'] = 0;
            $this->zmg_options['ZMG_PB_SP_OPTIONS'] = 0;
            $this->zmg_options['ZMG_PB_STYLE']      = 1;

            $this->zmg_options['clear_options'] =
                isset($_POST['clear_options']);

            if (isset($_POST['is_zmg_css']))
            {
                if ($_POST['is_zmg_css']) $this->zmg_options['is_zmg_css'] = 1;
                else
                {
                    $this->zmg_options['is_zmg_css'] = 0;

                    if (isset($_POST['css']))
                        $this->zmg_options['css'] =
                            stripslashes($_POST['css']);
                }
            }

            $this->zmg_save_options();

            ?>
                <div class="updated fade">
                    <p>
            <?
                _e('Options have been successfully saved', 'zmg_pagebar');
            ?>
                    </p>
                </div>
            <?
        }

        ?>
<ul id="zmg_pb_tabs">
    <li id="zmg_pb_tab_mp_options"
        <?= $this->zmg_options['ZMG_PB_MP_OPTIONS']
            ? 'class="zmg_tab_selected" >'
            : ' >'
        ?>
        <a href="#options" onclick="zmg_pb_show_mp_options(); return false;">
            <? _e('Blogroll navigation', 'zmg_pagebar'); ?>
        </a>
    </li>
    <li id="zmg_pb_tab_sp_options"
        <?= $this->zmg_options['ZMG_PB_SP_OPTIONS']
            ? 'class="zmg_tab_selected" >'
            : ' >'
        ?>
        <a href="#options" onclick="zmg_pb_show_sp_options(); return false;">
            <? _e('Quick links on single post', 'zmg_pagebar'); ?>
        </a>
    </li>
    <li id="zmg_pb_tab_style"
        <?= $this->zmg_options['ZMG_PB_STYLE']
            ? 'class="zmg_tab_selected" >'
            : ' >'
        ?>
        <a href="#style" onclick="zmg_pb_show_style(); return false;">
            <? _e('Common options & CSS', 'zmg_pagebar'); ?>
        </a>
    </li>
</ul>
<br />

<div id="zmg_pb_mp_options">
    <div class="updated">
        <p><? _e('Navigation bar shown on the index, category, tag, archive
                  browsing, search results and other lists',
                 'zmg_pagebar');
        ?></p>
    </div>
    <form action="" method="post">
        <input type="hidden" name="ZMG_PB_MP_OPTIONS" value="1" />
        <table class="form-table">
            <tr>
                <th>
                    <? _e('Where the pagebar must be inserted:',
                          'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="checkbox" name="before_loop" value="1"
                           id="zmg_pb_opt_before_loop"
                        <?= $this->zmg_options['before_loop']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_before_loop">
                        <? _e('before posts list', 'zmg_pagebar'); ?>
                    </label>
                    <br />
                    <input type="checkbox" name="after_loop" value="1"
                           id="zmg_pb_opt_after_loop"
                        <?= $this->zmg_options['after_loop']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_after_loop">
                        <? _e('after posts list', 'zmg_pagebar'); ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Left part', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="left" size="5"
                           id="zmg_pb_opt_left"
                           value="<?= $this->zmg_options['left'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_left">
                        <?
                            _e('Any positive number which defines amount of
                                links in the LEFT part of pagebar',
                               'zmg_pagebar');
                        ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Center part', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="center" size="5"
                           id="zmg_pb_opt_center"
                           value="<?= $this->zmg_options['center'] /*?>*/?>" />
                    <label for="zmg_pb_opt_center">
                        <?
                            _e('Any odd positive number which defines amount of
                                links in the CENTRAL part of pagebar. Note that
                                if you enter even number it will be increased
                                by one (to become odd one).',
                               'zmg_pagebar');
                        ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Right part', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="right" size="5"
                           id="zmg_pb_opt_right"
                           value="<?= $this->zmg_options['right'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_right">
                        <?
                            _e('Any positive number which defines amount of
                                links in the RIGHT part of pagebar',
                               'zmg_pagebar');
                        ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Separator', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="separator"
                           id="zmg_pb_opt_separator" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['separator']
                                 /*?>*/ ?>" />
                    <label for="zmg_pb_opt_separator">
                        <?
                            _e('Text separating pagebar central part from left
                                and rigth parts',
                               'zmg_pagebar');
                        ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Link to previous page:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <ul class="zmg_radio_buttons">
                        <li>
                            <input type="radio" name="prev_link" value="never"
                                   id="zmg_pb_opt_prev_link_never"
                                <?= $this->zmg_options["prev_link"] == "never"
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_prev_link_never">
                                <? _e('don\'t show', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                        <li>
                            <input type="radio" name="prev_link" value="auto"
                                   id="zmg_pb_opt_prev_link_auto"
                                <?= $this->zmg_options["prev_link"] == "auto"
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_prev_link_auto">
                                <? _e('auto', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                        <li>
                            <input type="radio" name="prev_link" value="always"
                                   id="zmg_pb_opt_prev_link_always"
                                <?= $this->zmg_options["prev_link"] == "always"
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_prev_link_always">
                                <? _e('always show', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                    </ul>
                    <input type="text" name="prev_tag"
                           id="zmg_pb_opt_prev_tag" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['prev_tag'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_prev_tag">
                        <?
                            _e('Text of the link to previous page ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('1'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Link to next page:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <ul class="zmg_radio_buttons">
                        <li>
                            <input type="radio" name="next_link" value="never"
                                   id="zmg_pb_opt_next_link_never"
                                <?= $this->zmg_options["next_link"] == "never"
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_next_link_never">
                                <? _e('don\'t show', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                        <li>
                            <input type="radio" name="next_link" value="auto"
                                   id="zmg_pb_opt_next_link_auto"
                                <?= $this->zmg_options["next_link"] == "auto"
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_next_link_auto">
                                <? _e('auto', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                        <li>
                            <input type="radio" name="next_link" value="always"
                                   id="zmg_pb_opt_next_link_always"
                                <?= $this->zmg_options["next_link"] == "always"
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_next_link_always">
                                <? _e('always show', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                    </ul>
                    <input type="text" name="next_tag"
                           id="zmg_pb_opt_next_tag" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['next_tag'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_next_tag">
                        <?
                            _e('Text of the link to next page ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('1'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Link to first page:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="first_tag"
                           id="zmg_pb_opt_first_tag" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['first_tag'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_first_tag">
                        <?
                            _e('Text of the link to first page ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('1'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Link to last page:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="last_tag"
                           id="zmg_pb_opt_last_tag" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['last_tag'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_last_tag">
                        <?
                            _e('Text of the link to last page ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('1'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Current page sign:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="curr_tag"
                           id="zmg_pb_opt_curr_tag" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['curr_tag'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_curr_tag">
                        <?
                            _e('Text defining the current page ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('1'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Common link text', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="stnd_tag"
                           id="zmg_pb_opt_stnd_tag" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['stnd_tag'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_stnd_tag">
                        <?
                            _e('Text of the link to other page i.e. which is not
                                described above ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('1'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Pop-up hints', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="checkbox" name="tooltips" value="1"
                           id="zmg_pb_opt_tooltips"
                           onClick="zmg_pb_s_h_hints();"
                        <?= $this->zmg_options['tooltips']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_tooltips">
                        <? _e('Show hints', 'zmg_pagebar'); ?>
                    </label>
                    <br />
                    <div id="zmg_pb_opt_ttip_tag_div">
                        <input type="text" name="ttip_tag"
                               id="zmg_pb_opt_ttip_tag"
                               class="zmg_pb_long_input"
                               value="<?= $this->zmg_options['ttip_tag'] /*?>*/ ?>" />
                        <label for="zmg_pb_opt_ttip_tag">
                            <?
                                _e('Text of on-hover hint', 'zmg_pagebar');
                            ?>
                        </label>
                    </div>
                    <?
                        if (! $this->zmg_options['tooltips'])
                        {
                    ?>
                        <script type="text/javascript"><!--
                            jQuery('#zmg_pb_opt_ttip_tag_div').hide();
                        //--></script>
                    <?
                        }
                    ?>
                </td>
            </tr>
            <tr>
                <th></th>
                <td>
                    <input class="button-primary" type="submit"
                           value="<? _e('Save', 'zmg_pagebar'); /*?>*/ ?>" />
                </td>
            </tr>
        </table>
    </form>
</div>
<?
        if (! $this->zmg_options['ZMG_PB_MP_OPTIONS'])
        {
?>
<script type="text/javascript"><!--
    jQuery('#zmg_pb_mp_options').hide();
//--></script>
<?
        }
?>

<div id="zmg_pb_sp_options">
    <div class="updated">
        <p><?
                _e('Links to `Previous post` and `Next post` shown on single
                    post', 'zmg_pagebar');
        ?></p>
    </div>
    <form action="" method="post">
        <input type="hidden" name="ZMG_PB_SP_OPTIONS" value="1" />
        <table class="form-table">
            <tr>
                <th>
                    <? _e('Where links must be inserted:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="checkbox" name="before_loop_s" value="1"
                           id="zmg_pb_opt_before_loop_s"
                        <?= $this->zmg_options['before_loop_s']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_before_loop_s">
                        <? _e('before post', 'zmg_pagebar'); ?>
                    </label>
                    <br />
                    <input type="checkbox" name="after_loop_s" value="1"
                           id="zmg_pb_opt_after_loop_s"
                        <?= $this->zmg_options['after_loop_s']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_after_loop_s">
                        <? _e('after post', 'zmg_pagebar'); ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Linking', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="checkbox" name="in_category" value="1"
                           id="zmg_pb_opt_in_category"
                        <?= $this->zmg_options['in_category']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_in_category">
                        <? _e('Show links to the same category posts only',
                              'zmg_pagebar');
                        ?>
                    </label>
                    <br />
                    <input type="checkbox" name="fl_linking" value="1"
                           id="zmg_pb_opt_fl_linking"
                        <?= $this->zmg_options['fl_linking']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_fl_linking">
                        <? _e('Crosslink newest and oldest posts (make links
                               circle)', 'zmg_pagebar');
                        ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Link to previous post:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="prev_tag_s" size="30"
                           id="zmg_pb_opt_prev_tag_s" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['prev_tag_s'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_prev_tag_s">
                        <?
                            _e('Text of the link to previos post ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('2'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Link to next post:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <input type="text" name="next_tag_s" size="30"
                           id="zmg_pb_opt_next_tag_s" class="zmg_pb_long_input"
                           value="<?= $this->zmg_options['next_tag_s'] /*?>*/ ?>" />
                    <label for="zmg_pb_opt_next_tag_s">
                        <?
                            _e('Text of the link to next post ',
                               'zmg_pagebar');
                        ?>
                        <a href="#help_for_zmg_tags"
                           onClick="zmg_pb_show_help('2'); return false;"
                           title"<? _e('Help on Zamango Pagebar tags',
                                       'zmg_pagebar'); /*?>*/ ?>"><?
                            _e('(Zamango tags and HTML are allowed)',
                               'zmg_pagebar');
                        ?></a>
                    </label>
                </td>
            </tr>
            <tr>
                <th></th>
                <td>
                    <input class="button-primary" type="submit"
                           value="<? _e('Save', 'zmg_pagebar'); /*?>*/ ?>" />
                </td>
            </tr>
        </table>
    </form>
</div>
<?
        if (! $this->zmg_options['ZMG_PB_SP_OPTIONS'])
        {
?>
<script type="text/javascript"><!--
    jQuery('#zmg_pb_sp_options').hide();
//--></script>
<?
        }
?>

<div id="zmg_pb_style">
    <div class="updated">
        <p><? _e('Common options (only one for now) & CSS customization',
                 'zmg_pagebar');
        ?></p>
    </div>
    <form action="" method="post">
        <input type="hidden" name="ZMG_PB_STYLE" value="1" />
        <table class="form-table">
            <tr>
                <th></th>
                <td>
                    <input type="checkbox" name="clear_options" value="1"
                           id="zmg_pb_opt_clear_options"
                        <?= $this->zmg_options['clear_options']
                            ? 'checked="checked" />'
                            : ' />'
                        ?>
                    <label for="zmg_pb_opt_clear_options">
                        <? _e('Delete options when deactivating the plugin',
                              'zmg_pagebar');
                        ?>
                    </label>
                </td>
            </tr>
            <tr>
                <th>
                    <? _e('Use CSS:', 'zmg_pagebar'); ?>
                </th>
                <td>
                    <ul class="zmg_radio_buttons2">
                        <li>
                            <input type="radio" name="is_zmg_css" value="1"
                                   id="zmg_pb_opt_is_zmg_css_true"
                                <?= $this->zmg_options["is_zmg_css"]
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_is_zmg_css_true">
                                <? _e('Default CSS', 'zmg_pagebar'); ?>
                            </label>
                        </li>
                        <li>
                            <input type="radio" name="is_zmg_css" value="0"
                                   id="zmg_pb_opt_is_zmg_css_false"
                                <?= (! $this->zmg_options["is_zmg_css"])
                                    ? ' checked="checked" />'
                                    : ' />'
                                ?>
                            <label for="zmg_pb_opt_is_zmg_css_false">
                                <? _e('Custom CSS:', 'zmg_pagebar'); ?>
                            </label>
                            <br />
                            <textarea rows="13" cols="80" name="css"
                                      id="zmg_pb_opt_css"><?=
                                $this->zmg_options['css']
                            ?></textarea>
                        </li>
                    </ul>
                </td>
            </tr>
            <tr>
                <th></th>
                <td>
                    <input class="button-primary" type="submit"
                           value="<? _e('Save', 'zmg_pagebar'); /*?>*/ ?>" />
                </td>
            </tr>
        </table>
    </form>
</div>
<?
        if (! $this->zmg_options['ZMG_PB_STYLE'])
        {
?>
<script type="text/javascript"><!--
    jQuery('#zmg_pb_style').hide();
//--></script>
<?
        }

        ?>
            </div>
            <div class="zmg_pb_clear"></div>
            <div id="zmg_pb_footer">
                <?
                    _e('Developed by',
                       'zmg_pagebar');
                ?>
                <a href="http://www.zamango.com" target=_blank>
                    Zamango
                </a>
            </div>
            <div id="zmg_pb_foot_baner">
                <h2>
                    <?
                       _e('Please check out other useful Zamango plugins
                           for Wordpress:', 'zmg_pagebar');
                    ?>
                </h2>
                <ul>
                    <li>
                        <a href="http://wordpress.org/extend/plugins/zamango-money-extractor/"
                           target=_blank title="<?
                            _e('Sell software from choosen vendors by only
                                one plugin', 'zmg_pagebar');
                        /*?>*/ ?>">Zamango Money Extractor</a>
                    </li>
                </ul>
            </div>
        <?

        $this->zmg_show_description('1');
        $this->zmg_show_description('2');
    }

    /**************************************************************************/
    function zmg_show_description($id)
    {
        ?>
<div id="zmg_pb_description<?= $id /*?>*/?>" class="zmg_pb_description">
  <div class="zmg_pb_desc_overlay"></div>
  <div class="zmg_pb_desc_window">
    <div class="zmg_pb_desc_top">
      <div class="zmg_pb_desc_title"><?
            _e('Help on Zamango tags', 'zmg_pagebar');
      ?></div>
      <div class="zmg_pb_desc_close">
        <a href="#help"
           onclick="zmg_pb_hide_help('<?= $id /*?>*/?>'); return false;">
          <img src="<?= ZMG_PB_URL ?>/img/close.png" />
        </a>
      </div>
    </div>
    <div id="zmg_pb_desc_content<?= $id /*?>*/?>" class="zmg_pb_desc_content">
      <?
        switch ($id)
        {
            case 1:
      ?>
      <p><?
        _e('You may use the following Zamango "tags" while configuring Page
            Navigation bar on lists pages', 'zmg_pagebar');
      ?></p>
      <ul>
        <li><code>[zmg_pb:current]</code>  <?
            _e('current page number (i.e. page on which the navigation bar
                is shown)', 'zmg_pagebar');
        ?></li>
        <li><code>[zmg_pb:total]</code>  <?
            _e('total pages amount', 'zmg_pagebar');
        ?></li>
        <li><code>[zmg_pb:page]</code>  <?
            _e('number of page which is processing by script for that moment
                (note that if page navigation bar contains links to 10 pages
                plus current then value of [zmg_pb:page] will have 11 values
                sequentially)', 'zmg_pagebar');
        ?></li>
      </ul>
      <p><? _e('Also you can use any HTML tags.', 'zmg_pagebar'); ?></p>
      <?
                break;

            case 2:
      ?>
      <p><?
        _e('You may use the following Zamango "tags" while configuring Page
            Navigation bar on single posts', 'zmg_pagebar');
      ?></p>
      <ul>
        <li><code>[zmg_pb:prev_post]</code>  <?
            _e('Title for link to previous post', 'zmg_pagebar');
        ?></li>
        <li><code>[zmg_pb:next_post]</code>  <?
            _e('Title for link to next post', 'zmg_pagebar');
        ?></li>
      </ul>
      <p><? _e('Also you can use any HTML tags.', 'zmg_pagebar'); ?></p>
      <?
                break;
        }//switch ($id)
      ?>
    </div>
  </div>
</div>
<?
    }

    /**************************************************************************/
    function zmg_is_my_page()
    {
        $page = explode("/", $_GET['page']);
        $file = explode("/", (__FILE__));
        return $page[count($page) - 1] == $file[count($file) - 1];
    }

    /**************************************************************************/
    function zmg_add_admin_css()
    {
        if ($this->zmg_is_my_page())
        {
            ?><link rel="stylesheet" media="screen"
                    href="<?= ZMG_PB_URL ?>/zmg_pb_admin.css" /><?
            ?><link rel="stylesheet" media="screen"
                    href="<?= ZMG_PB_URL ?>/zmg_pagebar.css" /><?
        }
    }

    /**************************************************************************/
    function zmg_add_admin_js()
    {
        if ($this->zmg_is_my_page())
        {
            wp_enqueue_script('jquery');
            ?><script type="text/javascript" src="<?=
                ZMG_PB_URL
            ?>/zmg_pagebar.js"></script><?
        }
    }

    /**************************************************************************/
    function zmg_add_css()
    {
        if ($this->zmg_options["is_zmg_css"])
        {
            ?><link rel="stylesheet" media="screen" href="<?=
                ZMG_PB_URL ?>/zmg_pagebar.css" /><?
        }
        else echo "\n<style type=\"text/css\">" . $this->zmg_options["css"] .
                  "</style>\n";
    }

    /**************************************************************************/
    function zmg_all_page_endpoint($vars)
    {
        $vars[] = 'all';
        return $vars;
    }
}

/******************************************************************************/
class zmg_pagebar_parser
{
    var $current_page;
    var $num_pages;
    var $options;
    var $id;

    /**************************************************************************/
    function zmg_pagebar_parser($id, $options)
    {
        $this->options      = $options;
        $this->id           = $id;
    }

    /**************************************************************************/
    function parse()
    {
        global $paged, $wp_query, $wpdb;

        if ($wp_query->is_feed) return 1;
        if (is_admin()) return 1;

        if (! is_single() && in_the_loop() &&
                ($this->options['before_loop'] &&
                 $this->id == "zmg_pb_before_loop" ||
                 $this->options['after_loop'] &&
                 $this->id == "zmg_pb_after_loop"))
        {
            $this->current_page = $paged;
            $this->num_pages    = intval($wp_query->max_num_pages);

            if ($this->num_pages <= 1) return 1;

            if (empty($this->current_page)) $this->current_page = 1;

            echo "\n<!-- Zamango Pagebar " . ZMG_PB_VERSION . " -->\n";
            echo "<div class='zmg_pb_clear'></div>";
            echo "<div class=\"zmg_pagebar\" id=\"" . $this->id . "\">\n";

            $this->prev_page();

            if ($this->num_pages <= $this->options["left"] +
                                    $this->options["center"] +
                                    $this->options["right"])
            {
                for ($i = 1; $i <= $this->num_pages; $i++)
                    if ($i == $this->current_page) $this->curr_page();
                    else $this->stnd_page($i);
            }
            else if ($this->current_page < $this->options["left"] +
                                           $this->options["center"])
            {
                $lc = $this->options["left"] + $this->options["center"];
                for ($i = 1; $i <= $lc; $i++)
                    if ($i == $this->current_page) $this->curr_page();
                    else $this->stnd_page($i);

                $this->separator();

                for ($i = $this->num_pages - $this->options["right"] +1;
                     $i <= $this->num_pages; $i++)
                    $this->stnd_page($i);
            }
            else if ($this->current_page - 1> $this->num_pages -
                     $this->options["center"] - $this->options["right"])
            {
                for ($i = 1; $i <= $this->options["left"]; $i++)
                    $this->stnd_page($i);

                $this->separator();

                for ($i = 1 + $this->num_pages - $this->options["center"] -
                          $this->options["right"]; $i <= $this->num_pages; $i++)
                    if ($i == $this->current_page) $this->curr_page();
                    else $this->stnd_page($i);
            }
            else
            {
                for ($i = 1; $i <= $this->options["left"]; $i++)
                    $this->stnd_page($i);

                $this->separator();

                $c = floor ($this->options["center"] / 2);
                for ($i = $this->current_page - $c;
                     $i <= $this->current_page + $c; $i++)
                    if ($i == $this->current_page) $this->curr_page();
                    else $this->stnd_page($i);

                $this->separator();

                for ($i = $this->num_pages - $this->options["right"] +1;
                     $i <= $this->num_pages; $i++)
                    $this->stnd_page($i);
            }

            $this->next_page();

            echo "</div>\n";
            echo "<div class='zmg_pb_clear'></div>";
            echo "<!-- Zamango Pagebar ".ZMG_PB_VERSION." -->\n";
            return 1;
        }
        else if (is_single() && in_the_loop() &&
                    ($this->options['before_loop_s'] &&
                     $this->id == "zmg_pb_before_loop" ||
                     $this->options['after_loop_s'] &&
                     $this->id == "zmg_pb_after_loop"))
        {
            $id = get_the_ID();

            $date = $wpdb->get_var("
                SELECT `post_date_gmt`
                  FROM `$wpdb->posts`
                 WHERE `ID` = '$id'
                 LIMIT 1
            ");

            if ($this->options['in_category'])
            {
                $cat_id = $wpdb->get_var("
                    SELECT `tr`.`term_taxonomy_id`
                      FROM `$wpdb->term_relationships` AS `tr`
                INNER JOIN `$wpdb->term_taxonomy` AS `tt`
                        ON `tr`.`term_taxonomy_id` = `tt`.`term_taxonomy_id`
                     WHERE `tr`.`object_id` = '$id'
                       AND `tt`.`taxonomy` = 'category'
                     LIMIT 1
                ");

                $query = "
                    SELECT `object_id`
                      FROM `$wpdb->term_relationships`
                     WHERE `term_taxonomy_id` = '$cat_id'
                ";

                $posts_id = $wpdb->get_results($query, ARRAY_N);

                if ($posts_id)
                {
                    $posts = array ();

                    foreach ($posts_id as $post_id)
                        array_push($posts, $post_id[0]);

                    $posts_in = implode(',', $posts);

                    $query = "
                        SELECT `post_date_gmt`, `ID`, `post_title`
                          FROM `$wpdb->posts`
                         WHERE `ID` IN ($posts_in)
                           AND `post_status` = 'publish'
                           AND `post_type` = 'post'
                      ORDER BY `post_date_gmt`, `ID`
                    ";

                    $sorted_posts = $wpdb->get_results($query, ARRAY_A);

                    $count = count($sorted_posts);

                    for ($i = 0; $i < $count &&
                                 $sorted_posts[$i]['ID'] != $id; $i++) {}

                    $prev = ($i == 0) ? (($this->options['fl_linking']) ?
                                        $sorted_posts[$count - 1] : NULL)
                                      : $sorted_posts[$i - 1];
                    $next = ($i == $count - 1) ? (($this->options['fl_linking'])
                                               ? $sorted_posts[0] : NULL)
                                               : $sorted_posts[$i + 1];

                }
            }
            else
            {
                $query = "
                    SELECT `ID`, `post_title`
                      FROM `$wpdb->posts`
                     WHERE `post_date_gmt` <= '$date'
                       AND `post_status` = 'publish'
                       AND `post_type` = 'post'
                  ORDER BY `post_date_gmt`, `ID`
                ";

                $sorted_posts = $wpdb->get_results($query, ARRAY_A);

                $count = count($sorted_posts);

                for ($i = 0; $i < $count &&
                             $sorted_posts[$i]['ID'] != $id; $i++) {}

                $prev = ($i == 0) ? (($this->options['fl_linking']) ?
                                    $sorted_posts[$count - 1] : NULL)
                                  : $sorted_posts[$i - 1];
                $next = ($i == $count - 1) ? (($this->options['fl_linking'])
                                           ? $sorted_posts[0] : NULL)
                                           : $sorted_posts[$i + 1];
            }

            if ($prev || $next)
            {
                echo "\n<!-- Zamango Pagebar " . ZMG_PB_VERSION . " -->\n";
                echo "<div class='zmg_pb_clear'></div>";
                echo "<div class=\"zmg_pagebar\" id=\"" . $this->id . "\">\n";

                if ($prev)
                {
                    echo "<span class='zmg_pb_prev_post'><a href='"
                         . get_permalink($prev['ID']) . "'>" .
                         str_replace("[zmg_pb:prev_post]", $prev['post_title'],
                                     $this->options['prev_tag_s']) .
                         "</a></span>\n";
                }

                if ($next)
                {
                    echo "<span class='zmg_pb_next_post'><a href='"
                         . get_permalink($next['ID']) . "'>" .
                         str_replace("[zmg_pb:next_post]", $next['post_title'],
                                     $this->options['next_tag_s']) .
                         "</a></span>\n";
                }

                echo "</div>\n";
                echo "<div class='zmg_pb_clear'></div>";
                echo "<!-- Zamango Pagebar ".ZMG_PB_VERSION." -->\n";
                return 1;
            }
        }
    }

    /**************************************************************************/
    function prev_page()
    {
        if ($this->options["prev_link"] == "never") return 1;
        if (($this->options["prev_link"] == "auto") &&
            ($this->current_page == 1)) return 1;

        echo ($this->current_page == 1) ?
            "<span class='zmg_pb_inactive zmg_pb_previous'>" .
            $this->replace_tags($this->options["prev_tag"], 0) . "</span>\n" :
            "<span class='zmg_pb_prev'><a href='" .
            $this->get_link($this->current_page - 1) . "'" .
            $this->get_tooltip($this->current_page - 1) . ">" .
            $this->replace_tags($this->options["prev_tag"],
                                $this->current_page - 1) . "</a></span>\n";
    }

    /**************************************************************************/
    function next_page()
    {
        if ($this->options["next_link"] == "never") return 1;
        if (($this->options["next_link"] == "auto") &&
            ($this->current_page == $this->num_pages)) return 1;

        echo ($this->current_page == $this->num_pages) ?
            "<span class='zmg_pb_inactive zmg_pb_next'>" .
            $this->replace_tags($this->options["next_tag"], 0) . "</span>\n" :
            "<span class='zmg_pb_next'><a href='" .
            $this->get_link($this->current_page + 1) . "'" .
            $this->get_tooltip($this->current_page + 1) . ">" .
            $this->replace_tags($this->options["next_tag"],
                                $this->current_page + 1) . "</a></span>\n";
    }

    /**************************************************************************/
    function curr_page()
    {
        echo "<span class='zmg_pb_current'>" .
             $this->replace_tags("", 0) . "</span>\n";
    }

    /**************************************************************************/
    function stnd_page($page)
    {
        echo "<span class='zmg_pb_standar'><a href='" . $this->get_link($page) .
            "'" . $this->get_tooltip($page) . ">" .
            $this->replace_tags("", $page) . "</a></span>\n";
    }

    /**************************************************************************/
    function separator()
    {
        echo "<span class='zmg_pb_separator'>";
        echo ($this->options["separator"] !== "") ?
              $this->options["separator"] : "...";
        echo"</span>\n";
    }

    /**************************************************************************/
    function get_link($page)
    {
        return get_pagenum_link($page);
    }

    /**************************************************************************/
    function get_tooltip($page)
    {
        if (! $this->options["tooltips"]) return "";
        return " title='" .
               $this->replace_tags($this->options["ttip_tag"], $page) . "'";
    }

    /**************************************************************************/
    function replace_tags($text, $page)
    {
        if (! $page) $page = $this->current_page;
        if (! $text)
        switch ($page)
        {
            case 1                   : $text = $this->options["first_tag"];
                break;
            case $this->num_pages    : $text = $this->options["last_tag"];
                break;
            case $this->current_page : $text = $this->options["curr_tag"];
                break;
            default                  : $text = $this->options["stnd_tag"];
        }

        $text = str_replace ("[zmg_pb:page]"   , $page, $text);
        $text = str_replace ("[zmg_pb:current]", $this->current_page, $text);
        $text = str_replace ("[zmg_pb:total]"  , $this->num_pages, $text);

        return $text;
    }
}
?>
